/* liblwevent/src/liblwevent/900_util.c
 *
 *  (c)2007, Laurence Withers, <l@lwithers.me.uk>.
 *  Released under the GNU GPLv3. See file COPYING or
 *  http://www.gnu.org/copyleft/gpl.html for details.
*/



/* lwevent_nonblock()
 *  Uses fcntl(2) to set O_NONBLOCK for `fd'. No-op if it is already set. Does not affect any other
 *  file status flags.
 */
int lwevent_nonblock(int fd)
{
    long flags;

    flags = TEMP_FAILURE_RETRY( fcntl(fd, F_GETFL) );
    if(flags == -1) return -1;

    if(flags & O_NONBLOCK) return 0;

    flags |= O_NONBLOCK;
    return TEMP_FAILURE_RETRY( fcntl(fd, F_SETFL, flags) );
}



/* lwevent_cloexec()
 *  Uses fcntl(2) to set FD_CLOEXEC for `fd'. No-op if it is already set. Does not affect any other
 *  file status flags.
 */
int lwevent_cloexec(int fd)
{
    long flags;

    flags = TEMP_FAILURE_RETRY( fcntl(fd, F_GETFD) );
    if(flags == -1) return -1;

    if(flags & FD_CLOEXEC) return 0;

    flags |= FD_CLOEXEC;
    return TEMP_FAILURE_RETRY( fcntl(fd, F_SETFD, flags) );
}



/* options for text editors
kate: replace-trailing-space-save true; space-indent true; tab-width 4;
vim: expandtab:ts=4:sw=4
*/
